<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="学校id" prop="schoolId">
        <el-input v-model="formData.schoolId" placeholder="请输入学校id" />
      </el-form-item>
      <el-form-item label="学校名称" prop="schoolName">
        <el-input v-model="formData.schoolName" placeholder="请输入学校名称" />
      </el-form-item>
      <el-form-item label="学历" prop="educationType">
        <el-select v-model="formData.educationType" placeholder="请选择学历">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_EDUCATION_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="学制类型" prop="educationSystemType">
        <el-select v-model="formData.educationSystemType" placeholder="请选择学制类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_EDUCATION_SYSTEM_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="专业id" prop="majorId">
        <el-input v-model="formData.majorId" placeholder="请输入专业id" />
      </el-form-item>
      <el-form-item label="专业名称" prop="major">
        <el-input v-model="formData.major" placeholder="请输入专业名称" />
      </el-form-item>
      <el-form-item label="在校开始日期" prop="startTime">
        <el-date-picker
          v-model="formData.startTime"
          type="date"
          value-format="x"
          placeholder="选择在校开始日期"
        />
      </el-form-item>
      <el-form-item label="在校结束时间" prop="endTime">
        <el-date-picker
          v-model="formData.endTime"
          type="date"
          value-format="x"
          placeholder="选择在校结束时间"
        />
      </el-form-item>
      <el-form-item label="在校经历" prop="content">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { EduExpApi, EduExpVO } from '@/api/menduner/system/eduexp'

/** 教育经历 表单 */
defineOptions({ name: 'EduExpForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  schoolId: undefined,
  schoolName: undefined,
  educationType: undefined,
  educationSystemType: undefined,
  majorId: undefined,
  major: undefined,
  startTime: undefined,
  endTime: undefined,
  content: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EduExpApi.getEduExp(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EduExpVO
    if (formType.value === 'create') {
      await EduExpApi.createEduExp(data)
      message.success(t('common.createSuccess'))
    } else {
      await EduExpApi.updateEduExp(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    schoolId: undefined,
    schoolName: undefined,
    educationType: undefined,
    educationSystemType: undefined,
    majorId: undefined,
    major: undefined,
    startTime: undefined,
    endTime: undefined,
    content: undefined
  }
  formRef.value?.resetFields()
}
</script>